Index: palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- palm/trunk/SOURCE/flow_statistics.f90	(revision 4645)
+++ palm/trunk/SOURCE/flow_statistics.f90	(revision 4646)
@@ -936,24 +880,24 @@
 !--             Buoyancy flux, water flux (humidity flux) w"q"
                 IF ( humidity ) THEN
-                   sums_l(k,45,tn) = sums_l(k,45,tn)                           &
-                                         - 0.5_wp * ( kh(k,j,i) + kh(k+1,j,i) )&
-                                               * ( vpt(k+1,j,i) - vpt(k,j,i) ) &
-                                               * rho_air_zw(k)                 &
-                                               * heatflux_output_conversion(k) &
+                   sums_l(k,45,tn) = sums_l(k,45,tn)                                               &
+                                         - 0.5_wp * ( kh(k,j,i) + kh(k+1,j,i) )                    &
+                                               * ( vpt(k+1,j,i) - vpt(k,j,i) )                     &
+                                               * rho_air_zw(k)                                     &
+                                               * heatflux_output_conversion(k)                     &
                                                * ddzu(k+1) * rmask(j,i,sr) * flag
-                   sums_l(k,48,tn) = sums_l(k,48,tn)                           &
-                                         - 0.5_wp * ( kh(k,j,i) + kh(k+1,j,i) )&
-                                               * ( q(k+1,j,i) - q(k,j,i) )     &
-                                               * rho_air_zw(k)                 &
-                                               * waterflux_output_conversion(k)&
+                   sums_l(k,48,tn) = sums_l(k,48,tn)                                               &
+                                         - 0.5_wp * ( kh(k,j,i) + kh(k+1,j,i) )                    &
+                                               * ( q(k+1,j,i) - q(k,j,i) )                         &
+                                               * rho_air_zw(k)                                     &
+                                               * waterflux_output_conversion(k)                    &
                                                * ddzu(k+1) * rmask(j,i,sr) * flag
 
                    IF ( bulk_cloud_model ) THEN
-                      sums_l(k,51,tn) = sums_l(k,51,tn)                        &
-                                         - 0.5_wp * ( kh(k,j,i) + kh(k+1,j,i) )&
-                                               * ( ( q(k+1,j,i) - ql(k+1,j,i) )&
-                                                - ( q(k,j,i) - ql(k,j,i) ) )   &
-                                               * rho_air_zw(k)                 &
-                                               * waterflux_output_conversion(k)&
+                      sums_l(k,51,tn) = sums_l(k,51,tn)                                            &
+                                         - 0.5_wp * ( kh(k,j,i) + kh(k+1,j,i) )                    &
+                                               * ( ( q(k+1,j,i) - ql(k+1,j,i) )                    &
+                                                - ( q(k,j,i) - ql(k,j,i) ) )                       &
+                                               * rho_air_zw(k)                                     &
+                                               * waterflux_output_conversion(k)                    &
                                                * ddzu(k+1) * rmask(j,i,sr) * flag
                    ENDIF
@@ -963,8 +907,8 @@
 !--             Passive scalar flux
                 IF ( passive_scalar )  THEN
-                   sums_l(k,117,tn) = sums_l(k,117,tn)                         &
-                                         - 0.5_wp * ( kh(k,j,i) + kh(k+1,j,i) )&
-                                                  * ( s(k+1,j,i) - s(k,j,i) )  &
-                                                  * ddzu(k+1) * rmask(j,i,sr)  &
+                   sums_l(k,117,tn) = sums_l(k,117,tn)                                             &
+                                         - 0.5_wp * ( kh(k,j,i) + kh(k+1,j,i) )                    &
+                                                  * ( s(k+1,j,i) - s(k,j,i) )                      &
+                                                  * ddzu(k+1) * rmask(j,i,sr)                      &
                                                               * flag
                 ENDIF
@@ -983,58 +927,59 @@
                    ki = -1 + l
                    IF ( surf_def_h(l)%ns >= 1 )  THEN
-                      DO  m = surf_def_h(l)%start_index(j,i),                  &
+                      DO  m = surf_def_h(l)%start_index(j,i),                                      &
                               surf_def_h(l)%end_index(j,i)
                          k = surf_def_h(l)%k(m)
 
                          !$ACC ATOMIC
-                         sums_l(k+ki,12,tn) = sums_l(k+ki,12,tn) + &
-                                    momentumflux_output_conversion(k+ki) * &
-                                    surf_def_h(l)%usws(m) * rmask(j,i,sr)     ! w"u"
+                         sums_l(k+ki,12,tn) = sums_l(k+ki,12,tn) +                                 &
+                                              momentumflux_output_conversion(k+ki) *               &
+                                              surf_def_h(l)%usws(m) * rmask(j,i,sr)     ! w"u"
                          !$ACC ATOMIC
-                         sums_l(k+ki,14,tn) = sums_l(k+ki,14,tn) + &
-                                    momentumflux_output_conversion(k+ki) * &
-                                    surf_def_h(l)%vsws(m) * rmask(j,i,sr)     ! w"v"
+                         sums_l(k+ki,14,tn) = sums_l(k+ki,14,tn) +                                 &
+                                              momentumflux_output_conversion(k+ki) *               &
+                                              surf_def_h(l)%vsws(m) * rmask(j,i,sr)     ! w"v"
                          !$ACC ATOMIC
-                         sums_l(k+ki,16,tn) = sums_l(k+ki,16,tn) + &
-                                    heatflux_output_conversion(k+ki) * &
-                                    surf_def_h(l)%shf(m)  * rmask(j,i,sr)     ! w"pt"
+                         sums_l(k+ki,16,tn) = sums_l(k+ki,16,tn) +                                 &
+                                              heatflux_output_conversion(k+ki) *                   &
+                                              surf_def_h(l)%shf(m)  * rmask(j,i,sr)     ! w"pt"
 #if 0
-                         sums_l(k+ki,58,tn) = sums_l(k+ki,58,tn) + &
-                                    0.0_wp * rmask(j,i,sr)        ! u"pt"
-                         sums_l(k+ki,61,tn) = sums_l(k+ki,61,tn) + &
-                                    0.0_wp * rmask(j,i,sr)        ! v"pt"
+                         sums_l(k+ki,58,tn) = sums_l(k+ki,58,tn) +                                 &
+                                              0.0_wp * rmask(j,i,sr)                    ! u"pt"
+                         sums_l(k+ki,61,tn) = sums_l(k+ki,61,tn) +                                 &
+                                              0.0_wp * rmask(j,i,sr)                    ! v"pt"
 #endif
 #ifndef _OPENACC
                          IF ( ocean_mode )  THEN
-                            sums_l(k+ki,65,tn) = sums_l(k+ki,65,tn) + &
-                                       surf_def_h(l)%sasws(m) * rmask(j,i,sr)  ! w"sa"
+                            sums_l(k+ki,65,tn) = sums_l(k+ki,65,tn) +                              &
+                                                 surf_def_h(l)%sasws(m) * rmask(j,i,sr)  ! w"sa"
                          ENDIF
                          IF ( humidity )  THEN
-                            sums_l(k+ki,48,tn) = sums_l(k+ki,48,tn) +                     &
-                                       waterflux_output_conversion(k+ki) *      &
-                                       surf_def_h(l)%qsws(m) * rmask(j,i,sr)  ! w"q" (w"qv")
-                            sums_l(k+ki,45,tn) = sums_l(k+ki,45,tn) + (                   &
-                                       ( 1.0_wp + 0.61_wp * q(k+ki,j,i) ) *     &
-                                       surf_def_h(l)%shf(m) + 0.61_wp * pt(k+ki,j,i) *      &
-                                                  surf_def_h(l)%qsws(m) )                  &
-                                       * heatflux_output_conversion(k+ki)
+                            sums_l(k+ki,48,tn) = sums_l(k+ki,48,tn) +                              &
+                                                 waterflux_output_conversion(k+ki) *               &
+                                                 surf_def_h(l)%qsws(m) * rmask(j,i,sr)  ! w"q" (w"qv")
+                            sums_l(k+ki,45,tn) = sums_l(k+ki,45,tn) +  (                           &
+                                                 ( 1.0_wp + 0.61_wp * q(k+ki,j,i) ) *              &
+                                                 surf_def_h(l)%shf(m) + 0.61_wp * pt(k+ki,j,i) *   &
+                                                 surf_def_h(l)%qsws(m) )                           &
+                                                 * heatflux_output_conversion(k+ki)
                             IF ( cloud_droplets )  THEN
-                               sums_l(k+ki,45,tn) = sums_l(k+ki,45,tn) + (                &
-                                         ( 1.0_wp + 0.61_wp * q(k+ki,j,i) -     &
-                                           ql(k+ki,j,i) ) * surf_def_h(l)%shf(m) +          &
-                                           0.61_wp * pt(k+ki,j,i) * surf_def_h(l)%qsws(m) ) &
-                                          * heatflux_output_conversion(k+ki)
+                               sums_l(k+ki,45,tn) = sums_l(k+ki,45,tn) +      (                    &
+                                                    ( 1.0_wp + 0.61_wp * q(k+ki,j,i) -             &
+                                                      ql(k+ki,j,i) ) * surf_def_h(l)%shf(m) +      &
+                                                      0.61_wp * pt(k+ki,j,i)                       &
+                                                      * surf_def_h(l)%qsws(m) )                    &
+                                                    * heatflux_output_conversion(k+ki)
                             ENDIF
                             IF ( bulk_cloud_model )  THEN
 !
 !--                            Formula does not work if ql(k+ki) /= 0.0
-                               sums_l(k+ki,51,tn) = sums_l(k+ki,51,tn) +                  &
-                                          waterflux_output_conversion(k+ki) *   &
-                                          surf_def_h(l)%qsws(m) * rmask(j,i,sr) ! w"q" (w"qv")
+                               sums_l(k+ki,51,tn) = sums_l(k+ki,51,tn) +                           &
+                                                    waterflux_output_conversion(k+ki) *            &
+                                                    surf_def_h(l)%qsws(m) * rmask(j,i,sr) ! w"q" (w"qv")
                             ENDIF
                          ENDIF
                          IF ( passive_scalar )  THEN
-                            sums_l(k+ki,117,tn) = sums_l(k+ki,117,tn) +                     &
-                                        surf_def_h(l)%ssws(m) * rmask(j,i,sr) ! w"s"
+                            sums_l(k+ki,117,tn) = sums_l(k+ki,117,tn) +                            &
+                                                  surf_def_h(l)%ssws(m) * rmask(j,i,sr) ! w"s"
                          ENDIF
 #endif
@@ -1044,114 +989,109 @@
                    ENDIF
                 ENDDO
-                IF ( surf_lsm_h%end_index(j,i) >=                              &
-                     surf_lsm_h%start_index(j,i) )  THEN
+                IF ( surf_lsm_h%end_index(j,i) >= surf_lsm_h%start_index(j,i) )  THEN
                    m = surf_lsm_h%start_index(j,i)
                    !$ACC ATOMIC
-                   sums_l(nzb,12,tn) = sums_l(nzb,12,tn) + &
-                                    momentumflux_output_conversion(nzb) * &
-                                    surf_lsm_h%usws(m) * rmask(j,i,sr)     ! w"u"
+                   sums_l(nzb,12,tn) = sums_l(nzb,12,tn) +                                         &
+                                       momentumflux_output_conversion(nzb) *                       &
+                                       surf_lsm_h%usws(m) * rmask(j,i,sr)     ! w"u"
                    !$ACC ATOMIC
-                   sums_l(nzb,14,tn) = sums_l(nzb,14,tn) + &
-                                    momentumflux_output_conversion(nzb) * &
-                                    surf_lsm_h%vsws(m) * rmask(j,i,sr)     ! w"v"
+                   sums_l(nzb,14,tn) = sums_l(nzb,14,tn) +                                         &
+                                       momentumflux_output_conversion(nzb) *                       &
+                                       surf_lsm_h%vsws(m) * rmask(j,i,sr)     ! w"v"
                    !$ACC ATOMIC
-                   sums_l(nzb,16,tn) = sums_l(nzb,16,tn) + &
-                                    heatflux_output_conversion(nzb) * &
-                                    surf_lsm_h%shf(m)  * rmask(j,i,sr)     ! w"pt"
+                   sums_l(nzb,16,tn) = sums_l(nzb,16,tn) +                                         &
+                                       heatflux_output_conversion(nzb) *                           &
+                                       surf_lsm_h%shf(m)  * rmask(j,i,sr)     ! w"pt"
 #if 0
-                   sums_l(nzb,58,tn) = sums_l(nzb,58,tn) + &
-                                    0.0_wp * rmask(j,i,sr)        ! u"pt"
-                   sums_l(nzb,61,tn) = sums_l(nzb,61,tn) + &
-                                    0.0_wp * rmask(j,i,sr)        ! v"pt"
+                   sums_l(nzb,58,tn) = sums_l(nzb,58,tn) +                                         &
+                                       0.0_wp * rmask(j,i,sr)        ! u"pt"
+                   sums_l(nzb,61,tn) = sums_l(nzb,61,tn) +                                         &
+                                       0.0_wp * rmask(j,i,sr)        ! v"pt"
 #endif
 #ifndef _OPENACC
                    IF ( ocean_mode )  THEN
-                      sums_l(nzb,65,tn) = sums_l(nzb,65,tn) + &
-                                       surf_lsm_h%sasws(m) * rmask(j,i,sr)  ! w"sa"
+                      sums_l(nzb,65,tn) = sums_l(nzb,65,tn) +                                      &
+                                          surf_lsm_h%sasws(m) * rmask(j,i,sr)  ! w"sa"
                    ENDIF
                    IF ( humidity )  THEN
-                      sums_l(nzb,48,tn) = sums_l(nzb,48,tn) +                     &
-                                       waterflux_output_conversion(nzb) *      &
-                                       surf_lsm_h%qsws(m) * rmask(j,i,sr)  ! w"q" (w"qv")
-                      sums_l(nzb,45,tn) = sums_l(nzb,45,tn) + (                   &
-                                       ( 1.0_wp + 0.61_wp * q(nzb,j,i) ) *     &
-                                       surf_lsm_h%shf(m) + 0.61_wp * pt(nzb,j,i) *      &
-                                                  surf_lsm_h%qsws(m) )                  &
-                                       * heatflux_output_conversion(nzb)
+                      sums_l(nzb,48,tn) = sums_l(nzb,48,tn) +                                      &
+                                          waterflux_output_conversion(nzb) *                       &
+                                          surf_lsm_h%qsws(m) * rmask(j,i,sr)  ! w"q" (w"qv")
+                      sums_l(nzb,45,tn) = sums_l(nzb,45,tn) + (                                    &
+                                          ( 1.0_wp + 0.61_wp * q(nzb,j,i) ) * surf_lsm_h%shf(m) +  &
+                                            0.61_wp * pt(nzb,j,i) * surf_lsm_h%qsws(m) )           &
+                                          * heatflux_output_conversion(nzb)
                       IF ( cloud_droplets )  THEN
-                         sums_l(nzb,45,tn) = sums_l(nzb,45,tn) + (                &
-                                         ( 1.0_wp + 0.61_wp * q(nzb,j,i) -     &
-                                           ql(nzb,j,i) ) * surf_lsm_h%shf(m) +          &
-                                           0.61_wp * pt(nzb,j,i) * surf_lsm_h%qsws(m) ) &
-                                          * heatflux_output_conversion(nzb)
+                         sums_l(nzb,45,tn) = sums_l(nzb,45,tn) + (                                 &
+                                             ( 1.0_wp + 0.61_wp * q(nzb,j,i) -                     &
+                                               ql(nzb,j,i) ) * surf_lsm_h%shf(m) +                 &
+                                               0.61_wp * pt(nzb,j,i) * surf_lsm_h%qsws(m) )        &
+                                             * heatflux_output_conversion(nzb)
                       ENDIF
                       IF ( bulk_cloud_model )  THEN
 !
 !--                      Formula does not work if ql(nzb) /= 0.0
-                         sums_l(nzb,51,tn) = sums_l(nzb,51,tn) +                  &
-                                          waterflux_output_conversion(nzb) *   &
-                                          surf_lsm_h%qsws(m) * rmask(j,i,sr) ! w"q" (w"qv")
+                         sums_l(nzb,51,tn) = sums_l(nzb,51,tn) +                                   &
+                                             waterflux_output_conversion(nzb) *                    &
+                                             surf_lsm_h%qsws(m) * rmask(j,i,sr) ! w"q" (w"qv")
                       ENDIF
                    ENDIF
                    IF ( passive_scalar )  THEN
-                      sums_l(nzb,117,tn) = sums_l(nzb,117,tn) +                     &
-                                        surf_lsm_h%ssws(m) * rmask(j,i,sr) ! w"s"
+                      sums_l(nzb,117,tn) = sums_l(nzb,117,tn) +                                    &
+                                           surf_lsm_h%ssws(m) * rmask(j,i,sr) ! w"s"
                    ENDIF
 #endif
 
                 ENDIF
-                IF ( surf_usm_h%end_index(j,i) >=                              &
-                     surf_usm_h%start_index(j,i) )  THEN
+                IF ( surf_usm_h%end_index(j,i) >= surf_usm_h%start_index(j,i) )  THEN
                    m = surf_usm_h%start_index(j,i)
                    !$ACC ATOMIC
-                   sums_l(nzb,12,tn) = sums_l(nzb,12,tn) + &
-                                    momentumflux_output_conversion(nzb) * &
-                                    surf_usm_h%usws(m) * rmask(j,i,sr)     ! w"u"
+                   sums_l(nzb,12,tn) = sums_l(nzb,12,tn) +                                         &
+                                       momentumflux_output_conversion(nzb) *                       &
+                                       surf_usm_h%usws(m) * rmask(j,i,sr)                ! w"u"
                    !$ACC ATOMIC
-                   sums_l(nzb,14,tn) = sums_l(nzb,14,tn) + &
-                                    momentumflux_output_conversion(nzb) * &
-                                    surf_usm_h%vsws(m) * rmask(j,i,sr)     ! w"v"
+                   sums_l(nzb,14,tn) = sums_l(nzb,14,tn) +                                         &
+                                       momentumflux_output_conversion(nzb) *                       &
+                                       surf_usm_h%vsws(m) * rmask(j,i,sr)                ! w"v"
                    !$ACC ATOMIC
-                   sums_l(nzb,16,tn) = sums_l(nzb,16,tn) + &
-                                    heatflux_output_conversion(nzb) * &
-                                    surf_usm_h%shf(m)  * rmask(j,i,sr)     ! w"pt"
+                   sums_l(nzb,16,tn) = sums_l(nzb,16,tn) +                                         &
+                                       heatflux_output_conversion(nzb) *                           &
+                                       surf_usm_h%shf(m)  * rmask(j,i,sr)                ! w"pt"
 #if 0
-                   sums_l(nzb,58,tn) = sums_l(nzb,58,tn) + &
-                                    0.0_wp * rmask(j,i,sr)        ! u"pt"
-                   sums_l(nzb,61,tn) = sums_l(nzb,61,tn) + &
-                                    0.0_wp * rmask(j,i,sr)        ! v"pt"
+                   sums_l(nzb,58,tn) = sums_l(nzb,58,tn) + 0.0_wp * rmask(j,i,sr)        ! u"pt"
+                   sums_l(nzb,61,tn) = sums_l(nzb,61,tn) + 0.0_wp * rmask(j,i,sr)        ! v"pt"
 #endif
 #ifndef _OPENACC
                    IF ( ocean_mode )  THEN
-                      sums_l(nzb,65,tn) = sums_l(nzb,65,tn) + &
-                                       surf_usm_h%sasws(m) * rmask(j,i,sr)  ! w"sa"
+                      sums_l(nzb,65,tn) = sums_l(nzb,65,tn) +                                      &
+                                          surf_usm_h%sasws(m) * rmask(j,i,sr)            ! w"sa"
                    ENDIF
                    IF ( humidity )  THEN
-                      sums_l(nzb,48,tn) = sums_l(nzb,48,tn) +                     &
-                                       waterflux_output_conversion(nzb) *      &
-                                       surf_usm_h%qsws(m) * rmask(j,i,sr)  ! w"q" (w"qv")
-                      sums_l(nzb,45,tn) = sums_l(nzb,45,tn) + (                   &
-                                       ( 1.0_wp + 0.61_wp * q(nzb,j,i) ) *     &
-                                       surf_usm_h%shf(m) + 0.61_wp * pt(nzb,j,i) *      &
-                                                  surf_usm_h%qsws(m) )                  &
-                                       * heatflux_output_conversion(nzb)
+                      sums_l(nzb,48,tn) = sums_l(nzb,48,tn) +                                      &
+                                          waterflux_output_conversion(nzb) *                       &
+                                          surf_usm_h%qsws(m) * rmask(j,i,sr)             ! w"q" (w"qv")
+                      sums_l(nzb,45,tn) = sums_l(nzb,45,tn) + (                                    &
+                                          ( 1.0_wp + 0.61_wp * q(nzb,j,i) ) *                      &
+                                          surf_usm_h%shf(m) + 0.61_wp * pt(nzb,j,i) *              &
+                                          surf_usm_h%qsws(m)  )                                    &
+                                          * heatflux_output_conversion(nzb)
                       IF ( cloud_droplets )  THEN
-                         sums_l(nzb,45,tn) = sums_l(nzb,45,tn) + (                &
-                                         ( 1.0_wp + 0.61_wp * q(nzb,j,i) -     &
-                                           ql(nzb,j,i) ) * surf_usm_h%shf(m) +          &
-                                           0.61_wp * pt(nzb,j,i) * surf_usm_h%qsws(m) ) &
-                                          * heatflux_output_conversion(nzb)
+                         sums_l(nzb,45,tn) = sums_l(nzb,45,tn) + (                                 &
+                                             ( 1.0_wp + 0.61_wp * q(nzb,j,i) -                     &
+                                              ql(nzb,j,i) ) * surf_usm_h%shf(m) +                  &
+                                              0.61_wp * pt(nzb,j,i) * surf_usm_h%qsws(m) )         &
+                                             * heatflux_output_conversion(nzb)
                       ENDIF
                       IF ( bulk_cloud_model )  THEN
 !
 !--                      Formula does not work if ql(nzb) /= 0.0
-                         sums_l(nzb,51,tn) = sums_l(nzb,51,tn) +                  &
-                                          waterflux_output_conversion(nzb) *   &
-                                          surf_usm_h%qsws(m) * rmask(j,i,sr) ! w"q" (w"qv")
+                         sums_l(nzb,51,tn) = sums_l(nzb,51,tn) +                                   &
+                                             waterflux_output_conversion(nzb) *                    &
+                                             surf_usm_h%qsws(m) * rmask(j,i,sr)          ! w"q" (w"qv")
                       ENDIF
                    ENDIF
                    IF ( passive_scalar )  THEN
-                      sums_l(nzb,117,tn) = sums_l(nzb,117,tn) +                     &
-                                        surf_usm_h%ssws(m) * rmask(j,i,sr) ! w"s"
+                      sums_l(nzb,117,tn) = sums_l(nzb,117,tn) +                                    &
+                                           surf_usm_h%ssws(m) * rmask(j,i,sr)            ! w"s"
                    ENDIF
 #endif
